package com.link.core.util;

import com.link.base.functiontime.model.FunctionTime;
import com.link.base.functiontime.service.FunctionTimeService;
import com.link.core.basic.thread.LinkThreadPoolExecutor;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.context.annotation.Configuration;

@Configuration
public class FunctionTimeUtil {
   private static final Logger logger = LogManager.getLogger(FunctionTimeUtil.class);
   private static List<FunctionTime> functionTimeList = new ArrayList();
   private static final Integer DEFAULT_INSERT_NUM = 500;

   public static void functionTime(String functionCode, String functionName, long startTime, long endTime, Boolean singleInsertFlag) {
      try {
         if (CoreYmlConstants.isIsRecord()) {
            Class var13 = FunctionTimeUtil.class;
            synchronized(FunctionTimeUtil.class) {
               if (singleInsertFlag != null && singleInsertFlag) {
                  setFunctionTimeList(functionCode, functionName, startTime, endTime);
               }

               if (functionTimeList.size() < DEFAULT_INSERT_NUM && (singleInsertFlag == null || !singleInsertFlag)) {
                  setFunctionTimeList(functionCode, functionName, startTime, endTime);
               } else {
                  List<FunctionTime> functionTimeListInsert = functionTimeList;
                  functionTimeList = new ArrayList();
                  LinkThreadPoolExecutor linkThreadPoolExecutor = (LinkThreadPoolExecutor)BeanTools.getBean("linkThreadPoolExecutor");

                  assert linkThreadPoolExecutor != null;

                  linkThreadPoolExecutor.execute(() -> {
                     try {
                        FunctionTimeService functionTimeService = (FunctionTimeService)BeanTools.getBean(FunctionTimeService.class);

                        assert functionTimeService != null;

                        functionTimeService.insert(functionTimeListInsert);
                     } catch (Exception var2) {
                        Exception e = var2;
                        logger.error(e.getMessage());
                     }

                  });
               }
            }
         }
      } catch (Exception var12) {
         Exception e = var12;
         logger.error("FunctionTimeUtil捕获异常: ", e);
      }

   }

   private static void setFunctionTimeList(String functionCode, String functionName, long startTime, long endTime) {
      FunctionTime functionTime = new FunctionTime();
      functionTime.setFunctionCode(functionCode);
      functionTime.setFunctionName(functionName);
      functionTime.setStartTime(DateUtil.dateToStr(new Date(startTime), "yyyy-MM-dd HH:mm:ss SSS"));
      functionTime.setEndTime(DateUtil.dateToStr(new Date(endTime), "yyyy-MM-dd HH:mm:ss SSS"));
      functionTime.setFunctionTime(div((double)(endTime - startTime), 1000.0, 3));
      functionTimeList.add(functionTime);
   }

   public static double div(double v1, double v2, int scale) {
      if (scale < 0) {
         throw new IllegalArgumentException("The scale must be a positive integer or zero");
      } else {
         BigDecimal b1 = new BigDecimal(Double.toString(v1));
         BigDecimal b2 = new BigDecimal(Double.toString(v2));
         return b1.divide(b2, scale, 4).doubleValue();
      }
   }
}
